//工商注册
const system = require("../../../system");
var settings = require("../../../../config/settings");
const AppServiceBase = require("../../app.base");
const regCfg = require("../../../api/impl/ic/regCfg");

class RegCenterOrderService extends AppServiceBase {
  constructor() {
    super();
    this.centerOrderUrl = settings.centerOrderUrl();
    this.execClient = system.getObject("util.execClient");
    this.cacheManager = system.getObject("db.common.cacheManager");
    this.utilsPushSve = system.getObject("service.utilsSve.utilsPushSve");
    this.opPushQueueUrl = settings.opPushQueueUrl();
    this.baiduclient = system.getObject("util.baiduClient");
    this.baiduRegclient = system.getObject("util.baiduRegclient");
    this.utilsOrderSve = system.getObject("service.utilsSve.utilsOrderSve");
  };
  //调用center-order 
  async reqCenterOrderApi(pobj, reqUrl) {
    var url = this.centerOrderUrl + "action/regCenterOrder/springBoard";
    if (reqUrl) {
      var url = this.centerOrderUrl + reqUrl;
    }
    var rtn = await this.execClient.execPost(pobj, url);
    var data = JSON.parse(rtn.stdout);
    return data;
  }
//调用center-order  reg需求反馈
async reqCenterOrderRegApi(pobj, reqUrl) {
  var url = this.centerOrderUrl + "action/regCenterOrderSve/springBoard";
  if (reqUrl) {
    var url = this.centerOrderUrl + reqUrl;
  }
  var self = this;
  pobj.actionType = "regFeedbackSubmit";
  if (pobj.actionBody && pobj.actionBody.intentionStatus) {
    pobj.intentionStatus = pobj.actionBody.intentionStatus;
  }
  var rtn = await this.execClient.execPost(pobj, url);
 
  if (pobj.intentionStatus) {
    // 如果需求当前字段为5（已关闭）则通知fq
    if (pobj.intentionStatus == 5) {
      self.utilsPushSve.aliBusiness2Fq(pobj, "pushCloseICPNeed");
    }
  }
  var data = JSON.parse(rtn.stdout);
  return data;
}

//-----------接入百度reg-----start--------laolan---2020.12.17----------------------
async regPaySuccess(pobj) {
  var sobj = {
    actionType: "getRegProduce",
    actionBody: { typeCode: pobj.actionBody.channelTypeCode, province: pobj.actionBody.province },
    appInfo: pobj.appInfo,
    actionProcess: pobj.actionProcess
  }

  var url = settings.centerAppUrl() + "action/opProduct/springBoard";
  var rtn = await this.execClient.execPost(sobj, url);
  if (!rtn || !rtn.stdout) {
    return system.getResultFail(-5010, "产品查询失败");
  }
  var data = JSON.parse(rtn.stdout);
  if (data.status != 0) {
    return system.getResultFail(-5010, "产品查询失败");
  }
  // pobj.actionBody = data.data;
  // pobj.actionBody.orderNo = pobj.actionBody.bizId;
  pobj.actionBody.totalSum = data.data.price;
  pobj.actionBody.orderPrice = data.data.price;
  pobj.actionBody.payTotalSum = data.data.price;
  pobj.actionBody.payCode = data.data.payCode;
  pobj.actionBody.channelItemCode = data.data.channelItemCode;
  pobj.actionBody.channelNeedNo = data.data.channelNeedNo;
  pobj.actionBody.needNo = data.data.needNo;
  pobj.actionBody.quantity = 1;
  pobj.actionBody.channelOrder = {
    channelServiceNo: pobj.actionBody.orderNo,
    channelOrderNo: pobj.actionBody.orderNo,
    orderStatus: 2
  }
  var orderrtn = await this.utilsOrderSve.addOrder(pobj, pobj.actionBody);
  if (orderrtn.status != 0 && orderrtn.status != -1) {
    return system.getResultFail(-5012, "订单创建失败");
  }
  if (orderrtn.data) {
    pobj.actionBody.orderNo = orderrtn.data.orderNo;
  }
  pobj.actionBody.channelSolutionNo = pobj.actionBody.bizId;

  pobj.actionType = "receiveSolutionPayInfoNew";
  var url = settings.centerOrderUrl() + "action/regCenterOrder/springBoard";
  var solutionrtn = await this.execClient.execPost(pobj, url);
  if (!solutionrtn || !solutionrtn.stdout) {
    return system.getResultFail(-5011, "方案查询失败");
  }
  var solutiondata = JSON.parse(solutionrtn.stdout);
  if (solutiondata.status != 0) {
    return system.getResultFail(-5011, "方案查询失败");
  }
  if (!solutiondata.data) {
    return system.getResultFail(-5012, "方案查询数据为空");
  }
  if (solutiondata.data && solutiondata.data.channelNeedNo) {
    pobj.actionBody.needId = solutiondata.data.channelNeedNo;
  }
  if (pobj.actionBody.channelItemCode) {
    pobj.actionBody.channelItemCode = regCfg.channelTypeCode[pobj.actionBody.channelItemCode];
  }
  var fqobj = {
    actionBody: {
      area: pobj.actionBody.province,
      idempotentSource: pobj.actionBody.regType,
      orderNo: pobj.actionBody.channelOrder.channelOrderNo,
      orderPrice: Number(pobj.actionBody.orderPrice / 100),
      phone: pobj.actionBody.publishMobile,
      needId: solutiondata.data.channelNeedNo,
      companyName:solutiondata.data.solutionContent.solution.CompanyName || ''
    },
    appInfo: pobj.appInfo
  }
  var baiduPushRes = await this.utilsPushSve.baiduBusiness2Fq(fqobj, "pushOrderICPBusinessNew");
  var deliveryObj = {
    actionBody: {
      orderNo: orderrtn.data.orderNo,//pobj.actionBody.channelOrder.channelOrderNo,
      needsolution: solutiondata.data.solutionContent,
      channelNeedNo: solutiondata.data.channelNeedNo,
      channelSolutionNo: solutiondata.data.channelSolutionNo,
      skuCode: data.data.payCode,
      servicer: {
        code: 'gsb',
        name: '公司宝'
      }
    },
    appInfo: pobj.appInfo
  };
  if(pobj.actionBody.isDirectBuy && pobj.actionBody.isDirectBuy==1){//直接下单需执行添加订单业务员操作
    if(baiduPushRes && baiduPushRes.status==0){
      if(baiduPushRes.data && baiduPushRes.data.data){
        var resData = baiduPushRes.data.data;
        var salesmanInfo = {
          salesmanName:resData.orderList && resData.orderList.length>0?resData.orderList[0].operatorName:"",
          salesmanChannelId:resData.orderList && resData.orderList.length>0?resData.orderList[0].operator:"",
        };
        var salesmanObj={
          appInfo:pobj.appInfo,
          actionType:"addRegSalesmanInfo",//添加业务员信息
          actionBody:{salesmanInfo:salesmanInfo,orderNo:orderrtn.data.orderNo}
        }; 
        var url = settings.centerOrderUrl() + "action/regCenterOrder/springBoard";
        var addRes = await this.execClient.execPost(salesmanObj, url);
        if (addRes && addRes.stdout) {
          var salesmanRes = JSON.parse(addRes.stdout);
          if (salesmanRes.status == 0) {
            deliveryObj.actionBody.needsolution = salesmanRes.data;
            await this.utilsPushSve.baiduBusiness2Delivery(deliveryObj, "pushDeliveryOrder");
          }
        }
        
      }
    }
  }else{
    this.utilsPushSve.baiduBusiness2Delivery(deliveryObj, "pushDeliveryOrder");
  }
  return system.getResultSuccess();
}
  // /**
  //   * 获取方案详情
  //   * @param {*} pobj
  //   * @param {*} actionBody bizId 渠道方案号
  //   */
  //  async getSolutionByChannelOrderNo(pobj, actionBody) {
  //   if (!actionBody.orderNo) {
  //     return system.getResult(null, "actionBody.orderNo can not be empty，100390");
  //   }
  //   var reqUrl = this.centerOrderUrl + "action/need/springBoard";
  //   var itemResult = await this.restPostUrl(pobj, reqUrl);
  //   return itemResult;
  // }

  /**
  * 获取需求详情
  * @param {*} pobj
  * @param {*} actionBody bizId 渠道方案号
  */
  async getItemByChannelSolutionNo(pobj, actionBody) {
    if (!actionBody.bizId) {
      return system.getResult(null, "actionBody.bizId can not be empty，100390");
    }
    var reqUrl = this.centerOrderUrl + "action/regCenterOrderSve/springBoard";
    var itemResult = await this.restPostUrl(pobj, reqUrl);
    return itemResult;
  }
  /**
    * 提交需求
    * @param {*} pobj
    * @param {*} actionBody
    */
  async submitRegNeed(pobj, actionBody) {
  
  if (!actionBody.intentionBizId) {
    return system.getResult(null, "actionBody.intentionBizId can not be empty，100380");
  }
  var sobj = pobj;
  sobj.actionType = "getProductTypeInfo";
  var url = settings.centerAppUrl() + "action/opProduct/springBoard";
  var rtn = await this.execClient.execPost(sobj, url);
  if (!rtn || !rtn.stdout) {
    return system.getResultFail(-5015, "需求類型查询失败");
  }
  var data = JSON.parse(rtn.stdout);
  if (data.status != 0) {
    return system.getResultFail(-5015, "需求類型查询失败");
  }
  pobj.actionBody.type_code = data.data.type_code;
  pobj.actionBody.type_name = data.data.type_name;
  pobj.actionBody.channel_type_code = data.data.channel_type_code;
  pobj.actionBody.channel_type_name = data.data.channel_type_name;
  pobj.actionBody.type = pobj.actionBody.channel_type_code;
  if (pobj.actionBody.channel_type_code) {
   pobj.actionBody.channel_type_code = regCfg.channelTypeCode[pobj.actionBody.channel_type_code]
  }
  if (pobj.actionBody.description && pobj.actionBody.description.indexOf("备#") < 0) {
    pobj.actionBody.level = "A";
  } else {
    // var levelurl = "http://106.13.228.212:8000/recProbability";
    // var levelresult = await this.restPostUrl({ intentionBizId: pobj.actionBody.intentionBizId, type: pobj.actionBody.type, note: pobj.actionBody.description }, levelurl);
    // if (levelresult.status == 0) {
    //   pobj.actionBody.level = levelresult.data.level;
    //   pobj.actionBody.probability = levelresult.data.per;
    // } else {
    //   pobj.actionBody.level = "C"
    // }
    pobj.actionBody.level = "C"
  }

  if (pobj.actionBody.phone == "17319425791") {
    pobj.actionBody.level = "F";
  }

  pobj.actionType = "submitRegNeed";
  var reqUrl = this.centerOrderUrl + "action/need/springBoard";
  var result = await this.restPostUrl(pobj, reqUrl);
  if (result.status == 0) {
      // var reqParams = {
      //   actionBody: pobj.actionBody,
      //   appInfo: pobj.appInfo
      // }
      // this.utilsPushSve.baiduBusiness2Delivery(reqParams, "addChance");

      pobj.actionBody.description = pobj.actionBody.description + "   成交概率：" + pobj.actionBody.level
      if (pobj.actionBody.probability) {
        pobj.actionBody.description = pobj.actionBody.description + "（" + pobj.actionBody.probability + "） "
      }
      pobj.actionBody.idempotentId = pobj.actionBody.intentionBizId;
      pobj.actionBody.idempotentSource = pobj.actionBody.type;
      pobj.actionBody.customerName = pobj.actionBody.userName;
      this.utilsPushSve.baiduBusiness2Fq(pobj, "pushNeedICPBusinessNew");
  }
  return result;
}
//状态更新
async regOrderStatus(pobj) {
  var actionBody = pobj.actionBody;
  var self = this;
  if (actionBody.isDirectBuy && actionBody.isDirectBuy == 1) {
    actionBody.bizId = actionBody.orderNo
  }
  if (!actionBody.bizId) {
    return system.getResult(null, "actionBody.bizId can not be empty，100495");
  }
  actionBody.BizId = actionBody.bizId;
  if (!actionBody.status) {
    return system.getResult(null, "actionBody.status can not be empty，100495");
  }
  pobj.actionType = "receiveOrderStatusNotify";
  var url = settings.centerOrderUrl() + "action/qcapi/springBoard";
  var rtn = await this.restPostUrl(pobj, url);
  if (actionBody.status == 2) {
    var deliveryObj = {
      actionBody: {
        orderNo: rtn.data.orderNo,//pobj.actionBody.channelOrder.channelOrderNo,
        needsolution: rtn.data.solutionContent,
        channelNeedNo: rtn.data.channelNeedNo,
        channelSolutionNo: rtn.data.channelSolutionNo,
        servicer: {
          code: 'gsb',
          name: '公司宝'
        }
      },
      appInfo: pobj.appInfo
    }
    this.utilsPushSve.baiduBusiness2Delivery(deliveryObj, "pushDeliveryOrder");
  }
  if (rtn.status == 0 && actionBody.status != 1 && actionBody.status != 2 && rtn.data) {
    var tmpObj = {
      actionBody: {
        orderNo: rtn.data.orderNo,
        channelNeedNo: rtn.data.channelNeedNo,
        needsolution: rtn.data.solutionContent
      },
      appInfo: pobj.appInfo
    }
    this.utilsPushSve.baiduBusiness2Delivery(tmpObj, "pushDeliveryStatusNotify");
    pobj.actionBody.orderNo = rtn.data.orderNo;
    if (actionBody.status == 11) {
      var orderrtn = await self.utilsOrderSve.delOrder(pobj, pobj.actionBody);
      if (orderrtn.status < 0) {
        return system.getResultFail(-5022, "订单关闭失败");
      }
      tmpObj.actionBody.orderNo = rtn.data.channelSolutionNo;
      self.utilsPushSve.baiduBusiness2Fq(tmpObj, "pushOrderICPClose");
    }
  }//通知更新状态
  return rtn;
}
//关闭reg订单
async regOrderClose(pobj) {
  var actionBody = pobj.actionBody;
  var self = this;
  var url = settings.centerOrderUrl() + "action/qcapi/springBoard";
  var rtn = await this.restPostUrl(pobj, url);
  if (rtn.status == 0 && rtn.data) {
    var channelOrderNo = pobj.actionBody.orderNo;
    pobj.actionBody.orderNo = rtn.data.orderNo;
    pobj.actionType="delOrder";
    var orderrtn = await self.utilsOrderSve.delOrder(pobj, actionBody);
    if (orderrtn.status < 0) {
      return system.getResultFail(-5022, "订单关闭失败");
    }
    var tmpObj = {
      actionBody: {
        orderNo: rtn.data.orderNo,
        channelNeedNo: rtn.data.channelNeedNo,
        needsolution: rtn.data.solutionContent
      },
      appInfo: pobj.appInfo
    }
    this.utilsPushSve.baiduBusiness2Delivery(tmpObj, "pushDeliveryStatusNotify");
    // tmpObj.actionBody.orderNo = channelOrderNo;
    var tmpObj2 = {
      actionBody: {
        orderNo: channelOrderNo,
        channelNeedNo: rtn.data.channelNeedNo,
        needsolution: rtn.data.solutionContent
      },
      appInfo: pobj.appInfo
    };
    self.utilsPushSve.baiduBusiness2Fq(tmpObj2, "pushOrderICPClose");
  }//通知更新状态
  return rtn;
}



  //提交reg注册方案
  async submitRegSolution(pobj) {
    console.log('reg ---  pobj -----',pobj)
    var res = await this.reqCenterOrderApi(pobj, "action/regapi/springBoard");
    if (res && res.status == 0 && res.data && res.data.needinfo && res.data.needsolutions) {
      console.log('reg ---  res -----',res)
      var needinfo = res.data.needinfo;//需求信息
      var needsolutions = res.data.needsolutions;//方案信息
      // var ab = pobj.actionBody;
      // if (typeof (ab.solutionContent) == "string") {
      //   ab.solutionContent = JSON.parse(ab.solutionContent);
      // }
      // if (typeof (needsolutions.solutionContent) == "string") {
      //   needsolutions.solutionContent = JSON.parse(needsolutions.solutionContent);
      // }
      // var solution = needsolutions.solutionContent.solution;
        var self = this;
        if(needinfo.uapp_id == regCfg.uappId.baidu){
          //推送数据至baidu
          // solution.Area = regCfg.baiduAreaCode[solution.Area]
          // console.log('solution.Area++',solution.Area)
          // var pushObj = {
          //   intentionBizId: needinfo.channelNeedNo,
          //   solutionList:{
          //     gsbBizId:"",
          //     bizType:"",
          //     solutionContent:""
          //   },
          // };
          var i=0;
          var needsolutionsLength = needsolutions.length;
          var bizTypes;
          var solutionList = [];
          for(i=0;i<needsolutionsLength;i++){
            bizTypes = needsolutions[i].solutionContent;
            console.log('bizTypes-----',bizTypes)
            bizTypes = JSON.parse(bizTypes)
            console.log('bizTypes++++',bizTypes)
            bizTypes.solution.serviceArea = regCfg.baiduAreaCode[bizTypes.solution.serviceArea]
            var list = {
              gsbBizId:needsolutions[i].solutionNo,
              bizType:bizTypes.bizType,
              solutionContent:bizTypes.solution
            }
            solutionList.push(list)
          }
           var pushObj = {
            intentionBizId: needinfo.channelNeedNo,
            solutionList:solutionList
          };
          console.log('pushObj---pushObj---',pushObj)
          // if (needsolutions.channelSolutionNo) {
          //   pushObj["bizId"] = needsolutions.channelSolutionNo;
          // }
          var pushBaiduRegSolution = await this.pushBaiduRegSolution(pushObj, needsolutions.solutionNo, pobj.appInfo, self);
        console.log('pushBaiduRegSolution+++',pushBaiduRegSolution)
        }
        this.logCtl.info({
          appid: pobj.appInfo ? pobj.appInfo.uapp_id || "" : "",
          appkey: pobj.appInfo ? pobj.appInfo.uapp_key || "" : "",
          requestId: pobj.requestId || "",
          op: "service/impl/common/regCenterOrderSve.js/submitSolution",
          content: JSON.stringify(pobj),
          resultInfo: JSON.stringify(needinfo),
          optitle: "createSolution推送蜂擎获取的接口信息->aliBusiness2Delivery",
        });
      
      var reqParams = {
        actionBody: {
          intentionBizId: needinfo.channelNeedNo,
          status: "createSolution"
        },
        appInfo: pobj.appInfo
      }
      await this.utilsPushSve.aliBusiness2Delivery(reqParams, "updateChanceStatus");
    }
    return res;
  }



  //推送reg方案
  async pushBaiduRegSolution(pushObj, solutionNo, appInfo, self) {
    console.log('pushObj++baidu+++',pushObj)
    //推送方案信息
    var pushRes = await self.baiduRegclient.baiduReqbyget({  path: "/v1/provider/demand?submitSolutions=", reqbody: pushObj });
    console.log("pushRes++++",pushRes)
    if (pushRes && pushRes.status == 0 && pushRes.data) {
      var resData = pushRes.data;
      if (resData.planId) {
        var reqObj2 = {
          actionType: "receiveProgrammeNo",
          appInfo: appInfo,
          actionBody: {
            solutionNo: solutionNo,
            solutionBizId: resData.planId
          }
        };
        var a = await self.reqCenterOrderApi(reqObj2);//保存渠道方案id
        console.log("保存渠道方案id aaaa++ ",a)
        if (a && a.status == 0 && resData.path) {
          var reqObj3 = {
            actionType: "receiveIcpConfirmUrl",
            appInfo: appInfo,
            actionBody: {
              solutionNo: solutionNo,
              confirmUrl: resData.path
            }
          };
          var url = await self.reqCenterOrderApi(reqObj3);//保存用户确认方案url
          console.log('save confirmUrl ++ ',url)
          return url;
        }
      }
    }
  }

  


  //提交交付信息/修改订单状态
  async updateOrdertatus(pobj) {
    var res = await this.reqCenterOrderApi(pobj, "action/regCenterOrder/springBoard");
    console.log('zzzzlllll+++++',res)
    console.log('zzzzlllll++pobj+++',pobj)
    if (res && res.status == 0 && res.data) {
      var needsolution = res.data;//方案信息
      var ab = pobj.actionBody;
      if (typeof (ab.material) == "string") {
        ab.material = JSON.parse(ab.material);
      }
      var material = ab.material;

      if(res.data.uapp_id == regCfg.uappId.baidu){
        //推送数据至百度 
        var BizId = needsolution.orderChannelNo;
        console.log('BizId++',BizId)
        var pushObj = {
          "businessLicense" : {
            "createdAt" : material.BusinessLicense.CreatedAt || "",
            "enterpriseCode" :material.BusinessLicense.EnterpriseCode || "",
            "legalRepresentative" :material.BusinessLicense.LegalRepresentative || "",
            "address" :material.BusinessLicense.Address || "",
            "registeredCapital" : material.BusinessLicense.RegisteredCapital || "",
            "name" :material.BusinessLicense.Name || "",
            "businessTerm" :material.BusinessLicense.BusinessTerm || "",
            "type" : material.BusinessLicense.Type || "",
            "scopeBusiness" :material.BusinessLicense.ScopeBusiness || ""
          },
          "partnerForeignInvestment": material.PartnerForeignInvestment || "",
          "orderNo": BizId,
          "domain": material.Domain,
          "corporateName": material.CorporateName,
          "includeForeignInvestment": material.IncludeForeignInvestment,
          "partnerBusinessLicense": material.PartnerBusinessLicense,
          "partnerIdCardList": material.PartnerIdCardList,
          "partnerDomainCertificate": material.PartnerDomainCertificate,
          "partnerPreviewOtherList": material.PartnerPreviewOtherList || [],
          "partnerPlan": material.PartnerPlan || "",
          "partnerLaw": material.PartnerLaw || "",
          "partnerStampOtherList": material.PartnerStampOtherList || [],
          "partnerSignOtherList": material.PartnerSignOtherList || [],
          "partnerSignAndStampOtherList": material.PartnerSignAndStampOtherList || []
        };
        var self = this;
        //推送交付信息/修改订单状态
        var baidu = await self.baiduclient.baiduReqbyget({ path: "/api/bla/provider/license/material", reqbody: pushObj });
        console.log('推送交付信息/修改订单状态baidu+++',baidu)
      }
      console.log('rsrsr++++------------++++',res)
      return res
    }
  }

 

  //通知交付状态变更
  // async serviceProviderNotification(pobj) {
  //   console.log('zhuangtai ++++',pobj)
  //   var res = await this.reqCenterOrderApi(pobj, "action/regCenterOrder/springBoard");
  //   if (res && res.status == 0 && res.data) {
  //     if(res.data.uapp_id == regCfg.uappId.baidu){
  //       res.data.ApplicationStatus = baiduRegStatus[res.data.ApplicationStatus];
  //       console.log('res.data.channelOrderNo',res.data.channelOrderNo)
  //       //推送数据至百度
  //       var pushObj = {
  //         orderNo: res.data.channelOrderNo,
  //         status: res.data.ApplicationStatus
  //       };
  //       //推送状态变更
  //       var baidu = await this.baiduclient.baiduReqbyget({ path: "/api/bla/provider/license/update", reqbody: pushObj });
  //       console.log('res.data baidu +++++',baidu)
  //       return res;
  //     }
  //   }
  // }

//-----------接入百度reg------end----------------------------------

}
module.exports = RegCenterOrderService;